package com.aliyun.vodplayer.demo;

import android.Manifest;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.os.Bundle;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.view.View;

import com.aliyun.vodplayer.demo.activity.advance.DemoDownloadActivity;
import com.aliyun.vodplayer.demo.activity.advance.DemoMultiPlayerActivity;
import com.aliyun.vodplayer.demo.activity.advance.DemoSwitchActivity;
import com.aliyun.vodplayer.demo.activity.advance.DemoVidstsActivity;

public class DemoAdvancePlayerActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_demo_advance_player);

        findViewById(R.id.vidsts).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                int storagePermissionRet = ContextCompat.checkSelfPermission(DemoAdvancePlayerActivity.this, Manifest.permission.WRITE_EXTERNAL_STORAGE);
                if (storagePermissionRet != PackageManager.PERMISSION_GRANTED) {
                    requestPermission();
                    return;
                }

                Intent intent = new Intent();
                intent.putExtra("type", "noskin");
                intent.setClass(DemoAdvancePlayerActivity.this, DemoVidstsActivity.class);
                startActivity(intent);
            }
        });

        findViewById(R.id.player_list).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent();
                intent.setClass(DemoAdvancePlayerActivity.this, DemoMultiPlayerActivity.class);
                startActivity(intent);
            }
        });

        findViewById(R.id.switch_url).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = new Intent();
                intent.setClass(DemoAdvancePlayerActivity.this, DemoSwitchActivity.class);
                startActivity(intent);
            }
        });

        findViewById(R.id.download_vid).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                int storagePermissionRet = ContextCompat.checkSelfPermission(DemoAdvancePlayerActivity.this, Manifest.permission.WRITE_EXTERNAL_STORAGE);
                if (storagePermissionRet != PackageManager.PERMISSION_GRANTED) {
                    requestPermission();
                    return;
                }

                Intent intent = new Intent();
                intent.setClass(DemoAdvancePlayerActivity.this, DemoDownloadActivity.class);
                startActivity(intent);
            }
        });


    }


    private int STORAGE_REQUEST_CODE = 100;

    private void requestPermission() {
        if (ContextCompat.checkSelfPermission(this, Manifest.permission.WRITE_EXTERNAL_STORAGE)
                != PackageManager.PERMISSION_GRANTED) {
            // 向用户解释为什么需要这个权限
            new AlertDialog.Builder(this)
                    .setMessage(R.string.require_permision_msg)
                    .setPositiveButton(R.string.ok, new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            //申请权限
                            ActivityCompat.requestPermissions(DemoAdvancePlayerActivity.this,
                                    new String[]{Manifest.permission.WRITE_EXTERNAL_STORAGE}, STORAGE_REQUEST_CODE);
                        }
                    })
                    .show();

        }
    }
}
