package com.aliyun.vodplayer.demo.activity;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.ViewGroup;
import android.view.ViewParent;
import android.webkit.WebView;

import com.aliyun.vodplayer.demo.R;
import com.aliyun.vodplayer.demo.utils.BaseAppCompatActivity;
import com.aliyun.vodplayer.demo.utils.CleanLeakUtils;

import java.util.Locale;

/**
 *
 */

public class DemoDiagnosisiActivity extends BaseAppCompatActivity {

    private WebView webView;

    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_diagnosis);

        webView = (WebView) findViewById(R.id.diagnosis);
        webView.getSettings().setJavaScriptEnabled(true);

        String souce = getIntent().getStringExtra("souce");
        String vid = getIntent().getStringExtra("vid");
        String lang = isZh() ? "zh-cn" : "en-us";
        webView.loadUrl("http://player.alicdn.com/detection.html?from=android&source=" + souce + "&vid=" + vid + "&lang=" + lang);
    }

    private boolean isZh() {
        Locale locale = getResources().getConfiguration().locale;
        String language = locale.getLanguage();
        if (language.endsWith("zh"))
            return true;
        else
            return false;
    }

    @Override
    protected void onDestroy() {
        CleanLeakUtils.freeWebview(webView);
        super.onDestroy();
    }


}
