package com.aliyun.vodplayer.demo.activity.advance;

import android.os.Bundle;
import android.os.Handler;
import android.support.v7.app.AppCompatActivity;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.WindowManager;

import com.aliyun.vodplayer.demo.R;
import com.aliyun.vodplayer.demo.utils.BaseAppCompatActivity;
import com.aliyun.vodplayer.demo.utils.CleanLeakUtils;
import com.aliyun.vodplayer.media.AliyunLocalSource;
import com.aliyun.vodplayer.media.AliyunVodPlayer;
import com.aliyun.vodplayer.media.IAliyunVodPlayer;

import java.lang.ref.WeakReference;

/**
 *
 */

public class DemoMultiPlayerActivity extends BaseAppCompatActivity implements View.OnClickListener {

    public static final String URL = "http://livecdn.video.taobao.com/temp/test1466295255657-65e172e6-1b96-4660-9f2f-1aba576d84e8.m3u8";

    private AliyunVodPlayer mPlayerOne, mPlayerTwo, mPlayerThree, mPlayerFour, mPlayerFive;
    private SurfaceView mSurfaceViewOne, mSurfaceViewTwo, mSurfaceViewThree, mSurfaceViewFour, mSurfaceViewFive;

    private Handler mHandler;

    private boolean CancelMember = false;

    private Runnable r1 = new Runnable() {
        public void run() {
            if (!CancelMember) {
                startPlayerOne();
            }
        }
    };
    private Runnable r2 = new Runnable() {
        public void run() {
            if (!CancelMember) {
                startPlayerTwo();
            }
        }
    };
    private Runnable r3 = new Runnable() {
        public void run() {
            if (!CancelMember) {
                startPlayerThree();
            }
        }
    };
    private Runnable r4 = new Runnable() {
        public void run() {
            if (!CancelMember) {
                startPlayerFour();
            }
        }
    };

    private Runnable r5 = new Runnable() {
        public void run() {
            if (!CancelMember) {
                startPlayerFive();
            }
        }
    };


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);

        setContentView(R.layout.activity_multi_player);

        mHandler = new Handler();

        mSurfaceViewOne = (SurfaceView) findViewById(R.id.PlayerOne);
        mSurfaceViewTwo = (SurfaceView) findViewById(R.id.PlayerTwo);
        mSurfaceViewThree = (SurfaceView) findViewById(R.id.PlayerThree);
        mSurfaceViewFour = (SurfaceView) findViewById(R.id.PlayerFour);
        mSurfaceViewFive = (SurfaceView) findViewById(R.id.PlayerFive);
        mSurfaceViewOne.setZOrderOnTop(true);
        mSurfaceViewTwo.setZOrderOnTop(true);
        mSurfaceViewThree.setZOrderOnTop(true);
        mSurfaceViewFour.setZOrderOnTop(true);
        mSurfaceViewFive.setZOrderOnTop(true);

        mSurfaceViewOne.setOnClickListener(this);
        mSurfaceViewTwo.setOnClickListener(this);
        mSurfaceViewThree.setOnClickListener(this);
        mSurfaceViewFour.setOnClickListener(this);
        mSurfaceViewFive.setOnClickListener(this);

        mSurfaceViewOne.getHolder().addCallback(new SurfaceHolder.Callback() {
            @Override
            public void surfaceCreated(SurfaceHolder surfaceHolder) {
                if(mPlayerOne!=null){
                    mPlayerOne.setDisplay(surfaceHolder);
                }
            }

            @Override
            public void surfaceChanged(SurfaceHolder surfaceHolder, int i, int i1, int i2) {
                if(mPlayerOne!=null){
                    mPlayerOne.surfaceChanged();
                }
            }

            @Override
            public void surfaceDestroyed(SurfaceHolder surfaceHolder) {

            }
        });

        mSurfaceViewTwo.getHolder().addCallback(new SurfaceHolder.Callback() {
            @Override
            public void surfaceCreated(SurfaceHolder surfaceHolder) {
                if(mPlayerTwo!=null){
                    mPlayerTwo.setDisplay(surfaceHolder);
                }
            }

            @Override
            public void surfaceChanged(SurfaceHolder surfaceHolder, int i, int i1, int i2) {
                if(mPlayerTwo!=null){
                    mPlayerTwo.surfaceChanged();
                }
            }

            @Override
            public void surfaceDestroyed(SurfaceHolder surfaceHolder) {

            }
        });

        mSurfaceViewThree.getHolder().addCallback(new SurfaceHolder.Callback() {
            @Override
            public void surfaceCreated(SurfaceHolder surfaceHolder) {
                if(mPlayerThree!=null){
                    mPlayerThree.setDisplay(surfaceHolder);
                }
            }

            @Override
            public void surfaceChanged(SurfaceHolder surfaceHolder, int i, int i1, int i2) {
                if(mPlayerThree!=null){
                    mPlayerThree.surfaceChanged();
                }
            }

            @Override
            public void surfaceDestroyed(SurfaceHolder surfaceHolder) {

            }
        });


        mSurfaceViewFour.getHolder().addCallback(new SurfaceHolder.Callback() {
            @Override
            public void surfaceCreated(SurfaceHolder surfaceHolder) {
                if(mPlayerFour!=null){
                    mPlayerFour.setDisplay(surfaceHolder);
                }
            }

            @Override
            public void surfaceChanged(SurfaceHolder surfaceHolder, int i, int i1, int i2) {
                if(mPlayerFour!=null){
                    mPlayerFour.surfaceChanged();
                }
            }

            @Override
            public void surfaceDestroyed(SurfaceHolder surfaceHolder) {

            }
        });

        mSurfaceViewFive.getHolder().addCallback(new SurfaceHolder.Callback() {
            @Override
            public void surfaceCreated(SurfaceHolder surfaceHolder) {
                if(mPlayerFive!=null){
                    mPlayerFive.setDisplay(surfaceHolder);
                }
            }

            @Override
            public void surfaceChanged(SurfaceHolder surfaceHolder, int i, int i1, int i2) {
                if(mPlayerFive!=null){
                    mPlayerFive.surfaceChanged();
                }
            }

            @Override
            public void surfaceDestroyed(SurfaceHolder surfaceHolder) {

            }
        });
    }

    @Override
    protected void onResume() {
        super.onResume();

        CancelMember = false;
        resumeAll();
    }

    private void resumeAll() {

        if (mPlayerOne != null && mPlayerOne.getPlayerState() == IAliyunVodPlayer.PlayerState.Paused) {
            mPlayerOne.resume();
        } else if (mPlayerOne == null && mHandler != null) {
            mHandler.postDelayed(r1, 1000);
        }

        if (mPlayerTwo != null && mPlayerTwo.getPlayerState() == IAliyunVodPlayer.PlayerState.Paused) {
            mPlayerTwo.resume();
        } else if (mPlayerTwo == null && mHandler != null) {
            mHandler.postDelayed(r2, 5000);
        }

        if (mPlayerThree != null && mPlayerThree.getPlayerState() == IAliyunVodPlayer.PlayerState.Paused) {
            mPlayerThree.resume();
        } else if (mPlayerThree == null && mHandler != null) {
            mHandler.postDelayed(r3, 10000);
        }

        if (mPlayerFour != null && mPlayerFour.getPlayerState() == IAliyunVodPlayer.PlayerState.Paused) {
            mPlayerFour.resume();
        } else if (mPlayerFour == null && mHandler != null) {
            mHandler.postDelayed(r4, 15000);
        }

        if (mPlayerFive != null && mPlayerFive.getPlayerState() == IAliyunVodPlayer.PlayerState.Paused) {
            mPlayerFive.resume();
        } else if (mPlayerFive == null && mHandler != null) {
            mHandler.postDelayed(r5, 20000);
        }

    }

    @Override
    protected void onStop() {
        super.onStop();

        CancelMember = true;
        pauseAll();

    }

    private void pauseAll() {
        if(mPlayerOne != null && mPlayerOne.getPlayerState() == IAliyunVodPlayer.PlayerState.Started) {
            mPlayerOne.pause();
        }
        if(mPlayerTwo != null && mPlayerTwo.getPlayerState() == IAliyunVodPlayer.PlayerState.Started) {
            mPlayerTwo.pause();
        }
        if(mPlayerThree != null && mPlayerThree.getPlayerState() == IAliyunVodPlayer.PlayerState.Started) {
            mPlayerThree.pause();
        }
        if(mPlayerFour != null && mPlayerFour.getPlayerState() == IAliyunVodPlayer.PlayerState.Started) {
            mPlayerFour.pause();
        }
        if(mPlayerFive != null && mPlayerFive.getPlayerState() == IAliyunVodPlayer.PlayerState.Started) {
            mPlayerFive.pause();
        }

    }


    private static class InnerAutoPlayListener implements IAliyunVodPlayer.OnAutoPlayListener
    {

        private WeakReference<DemoMultiPlayerActivity> activityWeakReference;
        private AliyunVodPlayer aliyunVodPlayer;
        public InnerAutoPlayListener(DemoMultiPlayerActivity activity , AliyunVodPlayer player){
            activityWeakReference = new WeakReference<DemoMultiPlayerActivity>(activity);
            aliyunVodPlayer = player;
        }

        @Override
        public void onAutoPlayStarted() {
            DemoMultiPlayerActivity activity = activityWeakReference.get();
            if(activity != null){
                activity.onAutoPlayStarted(aliyunVodPlayer);
            }
        }
    }

    private void onAutoPlayStarted(AliyunVodPlayer aliyunVodPlayer) {
        if(CancelMember){
            aliyunVodPlayer.pause();
        }
    }

    private void startPlayerOne() {
        mPlayerOne = new AliyunVodPlayer(getApplicationContext());
        mPlayerOne.setDisplay(mSurfaceViewOne.getHolder());
        String url = URL;
        AliyunLocalSource.AliyunLocalSourceBuilder asb = new AliyunLocalSource.AliyunLocalSourceBuilder();
        asb.setSource(url);
        mPlayerOne.enableNativeLog();
        mPlayerOne.setAutoPlay(true);
        mPlayerOne.setOnAutoPlayListener(new InnerAutoPlayListener(this, mPlayerOne));
        mPlayerOne.prepareAsync(asb.build());

    }

    private void startPlayerTwo() {
        mPlayerTwo = new AliyunVodPlayer(getApplicationContext());
        mPlayerTwo.setDisplay(mSurfaceViewTwo.getHolder());
        String url = URL;
        AliyunLocalSource.AliyunLocalSourceBuilder asb = new AliyunLocalSource.AliyunLocalSourceBuilder();
        asb.setSource(url);
        mPlayerTwo.enableNativeLog();
        mPlayerTwo.setAutoPlay(true);
        mPlayerTwo.setOnAutoPlayListener(new InnerAutoPlayListener(this, mPlayerTwo));
        mPlayerTwo.prepareAsync(asb.build());

    }

    private void startPlayerThree() {
        mPlayerThree = new AliyunVodPlayer(getApplicationContext());
        mPlayerThree.setDisplay(mSurfaceViewThree.getHolder());
        String url = URL;
        AliyunLocalSource.AliyunLocalSourceBuilder asb = new AliyunLocalSource.AliyunLocalSourceBuilder();
        asb.setSource(url);
        mPlayerThree.enableNativeLog();
        mPlayerThree.setAutoPlay(true);
        mPlayerThree.setOnAutoPlayListener(new InnerAutoPlayListener(this, mPlayerThree));
        mPlayerThree.prepareAsync(asb.build());
    }

    private void startPlayerFour() {
        mPlayerFour = new AliyunVodPlayer(getApplicationContext());
        mPlayerFour.setDisplay(mSurfaceViewFour.getHolder());
        String url = URL;
        AliyunLocalSource.AliyunLocalSourceBuilder asb = new AliyunLocalSource.AliyunLocalSourceBuilder();
        asb.setSource(url);
        mPlayerFour.enableNativeLog();
        mPlayerFour.setAutoPlay(true);
        mPlayerFour.setOnAutoPlayListener(new InnerAutoPlayListener(this, mPlayerFour));
        mPlayerFour.prepareAsync(asb.build());
    }

    private void startPlayerFive() {
        mPlayerFive = new AliyunVodPlayer(getApplicationContext());
        mPlayerFive.setDisplay(mSurfaceViewFive.getHolder());
        String url = URL;
        AliyunLocalSource.AliyunLocalSourceBuilder asb = new AliyunLocalSource.AliyunLocalSourceBuilder();
        asb.setSource(url);
        mPlayerFive.enableNativeLog();
        mPlayerFive.setAutoPlay(true);
        mPlayerFive.setOnAutoPlayListener(new InnerAutoPlayListener(this, mPlayerFive));
        mPlayerFive.prepareAsync(asb.build());
    }

    @Override
    protected void onDestroy() {

        mHandler.removeCallbacks(r1);
        mHandler.removeCallbacks(r2);
        mHandler.removeCallbacks(r3);
        mHandler.removeCallbacks(r4);
        mHandler.removeCallbacks(r5);
        mHandler = null;

        CancelMember = true;

        if(mPlayerOne != null) {
            mPlayerOne.stop();
            mPlayerOne.release();
            mPlayerOne = null;
        }
        if(mPlayerTwo != null) {
            mPlayerTwo.stop();
            mPlayerTwo.release();
            mPlayerTwo = null;
        }
        if(mPlayerThree != null) {
            mPlayerThree.stop();
            mPlayerThree.release();
            mPlayerThree = null;
        }
        if(mPlayerFour != null) {
            mPlayerFour.stop();
            mPlayerFour.release();
            mPlayerFour = null;
        }
        if(mPlayerFive != null) {
            mPlayerFive.stop();
            mPlayerFive.release();
            mPlayerFive = null;
        }

        super.onDestroy();
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.PlayerOne:
                if(mPlayerOne != null && mPlayerOne.getPlayerState() == IAliyunVodPlayer.PlayerState.Started) {
                    mPlayerOne.pause();
                } else if(mPlayerOne != null && mPlayerOne.getPlayerState() == IAliyunVodPlayer.PlayerState.Paused) {
                    mPlayerOne.resume();
                }
                break;
            case R.id.PlayerTwo:
                if(mPlayerTwo != null && mPlayerTwo.getPlayerState() == IAliyunVodPlayer.PlayerState.Started) {
                    mPlayerTwo.pause();
                } else if(mPlayerTwo != null && mPlayerTwo.getPlayerState() == IAliyunVodPlayer.PlayerState.Paused) {
                    mPlayerTwo.resume();
                }
                break;
            case R.id.PlayerThree:
                if(mPlayerThree != null && mPlayerThree.getPlayerState() == IAliyunVodPlayer.PlayerState.Started) {
                    mPlayerThree.pause();
                } else if(mPlayerThree != null && mPlayerThree.getPlayerState() == IAliyunVodPlayer.PlayerState.Paused) {
                    mPlayerThree.resume();
                }
                break;
            case R.id.PlayerFour:
                if(mPlayerFour != null && mPlayerFour.getPlayerState() == IAliyunVodPlayer.PlayerState.Started) {
                    mPlayerFour.pause();
                } else if(mPlayerFour != null && mPlayerFour.getPlayerState() == IAliyunVodPlayer.PlayerState.Paused) {
                    mPlayerFour.resume();
                }
                break;
            case R.id.PlayerFive:
                if(mPlayerFive != null && mPlayerFive.getPlayerState() == IAliyunVodPlayer.PlayerState.Started) {
                    mPlayerFive.pause();
                } else if(mPlayerFive != null && mPlayerFive.getPlayerState() == IAliyunVodPlayer.PlayerState.Paused) {
                    mPlayerFive.resume();
                }
                break;
        }
    }
}
