package com.aliyun.vodplayer.demo.activity.advance;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentStatePagerAdapter;

import com.aliyun.vodplayer.demo.R;
import com.aliyun.vodplayer.demo.utils.BaseAppCompatActivity;
import com.aliyun.vodplayer.demo.utils.NoPreloadViewPager;

import java.util.ArrayList;
import java.util.List;

/**
 *
 */

public class DemoSwitchActivity extends BaseAppCompatActivity {

    private NoPreloadViewPager mPlayingViewPager;
    private List<String> mLiveUrlList;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_demo_switch);
        initData();
        initView();
    }

    private void initData() {
        mLiveUrlList =  new ArrayList<>();
        for(int i=0;i<100;i+=4){
            mLiveUrlList.add("http://140.205.13.254/hls_video/TB26VJUbXXXXXaTXpXXXXXXXXXX/0.m3u8");
            mLiveUrlList.add("http://140.205.13.254/hls_video/TB2ChimbXXXXXavXXXXXXXXXXXX/0.m3u8");
            mLiveUrlList.add("http://140.205.13.254/hls_video/TB2UpXMbXXXXXX8XpXXXXXXXXXX/0.m3u8");
            mLiveUrlList.add("http://140.205.13.254/hls_video/TB2bp2ibXXXXXabXpXXXXXXXXXX/0.m3u8");
        }
    }

    private void initView() {
        mPlayingViewPager = (NoPreloadViewPager) findViewById(R.id.live_playing_viewpager);
        mPlayingViewPager.setAdapter(new PlayingFragmentAdapter(mLiveUrlList, getSupportFragmentManager()));
    }

    private class PlayingFragmentAdapter extends FragmentStatePagerAdapter {


        private List<String> mUrlList = new ArrayList<>();


        public PlayingFragmentAdapter(List<String> liveBeanList, FragmentManager supportFragmentManager) {
            super(supportFragmentManager);
            mUrlList.clear();
            mUrlList.addAll(liveBeanList);
        }

        @Override
        public Fragment getItem(int position) {
            DemoSwitchFragment testPlayingFragment = DemoSwitchFragment.newInstance(position);
            Bundle bundle = new Bundle();
            bundle.putString(DemoSwitchFragment.LIVEURL, mUrlList.get(position));
            testPlayingFragment.setArguments(bundle);
            return testPlayingFragment;
        }

        @Override
        public int getCount() {
            if (mUrlList == null) {
                return 0;
            }
            return mUrlList.size();
        }

        @Override
        public int getItemPosition(Object object) {
            return POSITION_NONE;
        }
    }
    @Override
    protected void onDestroy() {
        if(DemoSwitchFragment.aliyunVodPlayer != null){
            DemoSwitchFragment.aliyunVodPlayer.release();
            DemoSwitchFragment.aliyunVodPlayer = null;
        }
        super.onDestroy();
    }
}
