package com.aliyun.vodplayer.demo.activity.advance;

import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.text.TextUtils;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

import com.aliyun.vodplayer.demo.BuildConfig;
import com.aliyun.vodplayer.demo.R;
import com.aliyun.vodplayer.demo.utils.BaseAppCompatActivity;
import com.aliyun.vodplayer.demo.utils.CleanLeakUtils;
import com.aliyun.vodplayer.demo.utils.VidStsUtil;

import java.lang.ref.WeakReference;

import static com.aliyun.vodplayer.demo.R.id.vid;

/**
 */

public class DemoUiPlayerActivity extends BaseAppCompatActivity {

    private EditText mVidEdit;
    private EditText mAkIdEdit, mAkSecretEdit, mScuTokenEdit;
    private String mVid;
    private boolean inRequest = false;
    private boolean isFixed = false;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_demo_ui_player);
        //填写vid等信息。
        mVidEdit = (EditText) findViewById(vid);
        mAkIdEdit = (EditText) findViewById(R.id.akId);
        mAkSecretEdit = (EditText) findViewById(R.id.akSecret);
        mScuTokenEdit = (EditText) findViewById(R.id.scuToken);

        if(!BuildConfig.DEBUG){
            findViewById(R.id.sts_view).setVisibility(View.GONE);
        }

        //点击事件
        findViewById(R.id.with_skin).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                startSkinActivity(false);
            }
        });
        findViewById(R.id.fix_skin).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                startSkinActivity(true);
            }
        });
    }

    private void startSkinActivity(final boolean fixed) {
        isFixed = fixed;
        mVid = mVidEdit.getText().toString();
        String akId = mAkIdEdit.getText().toString();
        String akSecret = mAkSecretEdit.getText().toString();
        String scuToken = mScuTokenEdit.getText().toString();

        if (TextUtils.isEmpty(mVid) || TextUtils.isEmpty(akId) || TextUtils.isEmpty(akSecret) || TextUtils.isEmpty(scuToken)) {
            if(inRequest){
                return;
            }
            inRequest = true;
            VidStsUtil.getVidSts(new MyStsListener(this));

        } else {
            Intent intent = new Intent();
            if (!fixed) {
                intent.setClass(this, SkinActivity.class);
            } else {
                intent.setClass(this, FixedSkinActivity.class);
            }
            //将vid等信息传递过去

            intent.putExtra("type", "vidsts");
            intent.putExtra("vid", mVid);
            intent.putExtra("akId", akId);
            intent.putExtra("akSecret", akSecret);
            intent.putExtra("scuToken", scuToken);

            startActivity(intent);

        }

    }


    private static class MyStsListener implements VidStsUtil.OnStsResultListener{

        private WeakReference<DemoUiPlayerActivity> weakctivity;

        public MyStsListener(DemoUiPlayerActivity view)
        {
            weakctivity = new WeakReference<DemoUiPlayerActivity>(view);
        }

        @Override
        public void onSuccess(String akid, String akSecret, String token) {
            DemoUiPlayerActivity activity = weakctivity.get();
            if(activity != null){
                activity.onStsSuccess(akid,akSecret,token);
            }
        }

        @Override
        public void onFail() {
            DemoUiPlayerActivity activity = weakctivity.get();
            if(activity != null){
                activity.onStsFail();
            }
        }
    }

    private void onStsFail() {

        Toast.makeText(DemoUiPlayerActivity.this.getApplicationContext(), R.string.request_vidsts_fail, Toast.LENGTH_LONG).show();
        inRequest = false;
    }

    private void onStsSuccess(String akid, String akSecret, String token) {
        Intent intent = new Intent();
        if (!isFixed) {
            intent.setClass(DemoUiPlayerActivity.this, SkinActivity.class);
        } else {
            intent.setClass(DemoUiPlayerActivity.this, FixedSkinActivity.class);
        }
        //将vid等信息传递过去
        intent.putExtra("type", "vidsts");
        intent.putExtra("vid", mVid);
        intent.putExtra("akId", akid);
        intent.putExtra("akSecret", akSecret);
        intent.putExtra("scuToken", token);

        startActivity(intent);

        inRequest = false;
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
    }
}
